diff --git a/include/log4cpp/TimeRollingFileAppender.hh b/include/log4cpp/TimeRollingFileAppender.hh
new file mode 100644
index 0000000..666a012
--- /dev/null
+++ b/include/log4cpp/TimeRollingFileAppender.hh
@@ -0,0 +1,127 @@
+/*
+ * TimeRollingFileAppender.hh
+ *
+ * Copyright 2009, Thomas Zhang. All rights reserved.
+ *
+ * See the COPYING file for the terms of usage and distribution.
+ */
+
+#ifndef _LOG4CPP_TIMEROLLINGFILEAPPENDER_HH
+#define _LOG4CPP_TIMEROLLINGFILEAPPENDER_HH
+
+#include <log4cpp/Portability.hh>
+#include <log4cpp/LayoutAppender.hh>
+#include <string>
+#include <list>
+#include <stdarg.h>
+
+namespace log4cpp {
+
+	/**
+	  TimeRollingFileAppender is a appender like the FileAppender that rolls over the logfile once
+	  it has reached a certain size limit.
+	  TimeRollingFileAppender rolls over the logfile on the certain time.
+	  @since 0.3.1
+	 **/
+	class LOG4CPP_EXPORT TimeRollingFileAppender : public LayoutAppender {
+		public:
+
+			/**
+			  Constructs a TimeRollingFileAppender.
+			  @param name the name of the Appender.
+			  @param fileName the name of the file to which the Appender has 
+			  to log.
+			  @param maxFileAge the interval of rolling over the logfile.
+			  @param backupPattern the time pattern of the logfile name .
+			  @param append whether the Appender has to truncate the file or
+			  just append to it if it already exists. Defaults to 'true'.
+			  @param mode file mode to open the logfile with. Defaults to 00644.
+			 **/  
+			TimeRollingFileAppender(const std::string& name, const std::string& fileName,
+					time_t maxFileAge, std::string backupPattern,
+					bool append = true, mode_t mode = 00644);
+
+			virtual ~TimeRollingFileAppender();
+
+			/**
+			  Reopens the logfile. 
+			  This can be useful for logfiles that are rotated externally,
+			  e.g. by logrotate. This method is a NOOP for FileAppenders that
+			  have been constructed with a file descriptor.           
+			  @returns true if the reopen succeeded.
+			 **/
+			virtual bool reopen();
+
+			/**
+			  Closes the logfile.
+			 **/
+			virtual void close();
+
+			/**
+			  Sets the append vs truncate flag.
+			  NB. currently the TimeRollingFileAppender opens the logfile in the 
+			  constructor. Therefore this method is too late to influence the 
+			  first file opening. We'll need something similar to log4j's
+			  activateOptions().
+			  @param append false to truncate, true to append
+			 **/
+			virtual void setAppend(bool append);
+
+			/**
+			  Gets the value of the 'append' option.
+			 **/
+			virtual bool getAppend() const;
+
+			/**
+			  Sets the file open mode.
+			 **/
+			virtual void setMode(mode_t mode);
+
+			/**
+			  Gets the file open mode.
+			 **/
+			virtual mode_t getMode() const;
+
+			/**
+			  Sets the time pattern of the logfile name 
+			  @param backupPattern the time string's format specification that
+			  introduced by a '%' character.
+			 **/
+			virtual void setBackupPattern(std::string backupPattern);
+
+			/**
+			  Gets the time pattern.
+			 **/
+			virtual std::string getBackupPattern() const;
+
+			/**
+			 * Sets the backup file numbers
+			 **/
+			virtual void setBackupIndex(int nIndex);
+
+			/**
+			 * Gets the backup file numbers
+			 **/
+			virtual int getBackupIndex();
+
+		protected:
+			virtual void _append(const LoggingEvent& event);
+			std::list<std::string> _fileNameList;
+
+			std::string _fileName;
+			int _fd;
+			int _flags;
+			mode_t _mode;
+
+			std::string  _backupPattern;
+			time_t _maxFileAge;
+			std::string _fileNamePrefix;
+			time_t _fileCreateTime;
+			int _backupIndex;
+
+			//static std::string concatLogfileName(const time_t now, const time_t maxFileAge, const std::string& fileNamePrefix, time_t& fileCreateTime);
+
+	};
+}
+
+#endif // _LOG4CPP_TIMEROLLINGFILEAPPENDER_HH
diff --git a/include/log4cpp/config-openvms.h b/include/log4cpp/config-openvms.h
index 792c7b0..684e20b 100644
--- a/include/log4cpp/config-openvms.h
+++ b/include/log4cpp/config-openvms.h
@@ -60,7 +60,7 @@
 
 /* Version number of package */
 #ifndef LOG4CPP_VERSION 
-#define LOG4CPP_VERSION  "1.0" 
+#define LOG4CPP_VERSION  "1.1.2" 
 #endif
  
 /* _INCLUDE_LOG4CPP_CONFIG_OPENVMS_H */
diff --git a/log4cpp-config.in b/log4cpp-config.in
index e21a20c..433ed88 100755
--- a/log4cpp-config.in
+++ b/log4cpp-config.in
@@ -40,6 +40,7 @@ for i ; do
     --sbindir) echo_sbindir="yes" ;;
     --libexecdir) echo_libexecdir="yes" ;;
     --datadir) echo_datadir="yes" ;;
+    --datarootdir) echo_datarootdir="yes" ;;
     --sysconfdir) echo_sysconfdir="yes" ;;
     --sharedstatedir) echo_sharedstatedir="yes" ;;
     --localstatedir) echo_localstatedir="yes" ;;
@@ -78,6 +79,9 @@ fi
 if test -z "$datadir" ; then
   datadir="@datadir@"
 fi
+if test -z "$datarootdir" ; then
+  datarootdir="@datarootdir@"
+fi
 if test -z "$sysconfdir" ; then
   sysconfdir="@sysconfdir@"
 fi
@@ -156,6 +160,9 @@ fi
 if test x$echo_datadir = xyes ; then
   o=" $datadir"
 fi
+if test x$echo_datarootdir = xyes ; then
+  o=" $datarootdir"
+fi
 if test x$echo_sysconfdir = xyes ; then
   o=" $sysconfdir"
 fi
@@ -228,6 +235,7 @@ All available options:
   --sbindir          \$sbindir       $sbindir
   --libexecdir       \$libexecdir    $libexecdir
   --datadir          \$datadir       $datadir
+  --datarootdir      \$datarootdir   $datarootdir
   --sysconfdir       \$sysconfdir    $sysconfdir
   --sharedstatedir   \$sharedstatedir$sharedstatedir
   --localstatedir    \$localstatedir $localstatedir
diff --git a/m4/BB_CHECK_PTHREADS.m4 b/m4/BB_CHECK_PTHREADS.m4
index 669b6e3..8e76d1d 100644
--- a/m4/BB_CHECK_PTHREADS.m4
+++ b/m4/BB_CHECK_PTHREADS.m4
@@ -6,12 +6,11 @@ AC_REQUIRE([AC_PROG_CXX])dnl
 AC_REQUIRE([AC_PROG_CPP])dnl
 AC_REQUIRE([AC_PROG_CXXCPP])dnl
 
-
-AC_ARG_WITH(pthreads, [  --with-pthreads         include pthreads support],
-    AC_SEARCH_LIBS(pthread_key_create,pthread,
+AC_ARG_WITH([pthreads], [  --with-pthreads         include pthreads support],
+    [AC_SEARCH_LIBS([pthread_key_create], [pthread],
         [AC_DEFINE(HAVE_THREADING,,[define if threading is enabled])
          AC_DEFINE(USE_PTHREADS,,[define if pthread library is available])
          AC_DEFINE(_PTHREADS,,[define for STL if pthread library is used])],
-    AC_MSG_ERROR([pthreads not found])))
+    [AC_MSG_ERROR([pthreads not found])])])
 
 ])
diff --git a/m4/ac_config_libconfig_in.m4 b/m4/ac_config_libconfig_in.m4
index 1545cb2..636b8c2 100644
--- a/m4/ac_config_libconfig_in.m4
+++ b/m4/ac_config_libconfig_in.m4
@@ -120,7 +120,7 @@ echo 'o=""' >>$LIBCONFIG_FILE
 echo 'h=""' >>$LIBCONFIG_FILE
 echo 'for i ; do' >>$LIBCONFIG_FILE
 echo '  case $i in' >>$LIBCONFIG_FILE
-options="prefix exec-prefix eprefix package version cflags libs bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir infodir mandir target host build pkgdatadir pkglibdir pkgincludedir template-version help"
+options="prefix exec-prefix eprefix package version cflags libs bindir sbindir libexecdir datadir datarootdir sysconfdir sharedstatedir localstatedir libdir infodir mandir target host build pkgdatadir pkglibdir pkgincludedir template-version help"
 echo '    --prefix=*) prefix=`echo $i | sed -e "s/--prefix=//"` ;;' >>$LIBCONFIG_FILE
 echo '    --exec-prefix=*) exec_prefix=`echo $i | sed -e "s/--exec-prefix=//"` ;;' >>$LIBCONFIG_FILE
 echo '    --eprefix=*) exec_prefix=`echo $i | sed -e "s/--eprefix=//"` ;;' >>$LIBCONFIG_FILE
@@ -143,7 +143,7 @@ echo 'done' >>$LIBCONFIG_FILE
 echo ' ' >>$LIBCONFIG_FILE
 # in the order of occurence a standard automake Makefile
 echo '# defaults from configure; set only if not set previously' >>$LIBCONFIG_FILE
-vars="prefix exec_prefix bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir infodir mandir includedir target host build"
+vars="prefix exec_prefix bindir sbindir libexecdir datadir datarootdir sysconfdir sharedstatedir localstatedir libdir infodir mandir includedir target host build"
 for var in $vars ; do
   echo "if test -z \"\$$var\" ; then" >>$LIBCONFIG_FILE
   echo "  $var=\"@$var@\"" >>$LIBCONFIG_FILE
@@ -209,6 +209,7 @@ echo '  --bindir           \$bindir        $bindir' >>$LIBCONFIG_FILE
 echo '  --sbindir          \$sbindir       $sbindir' >>$LIBCONFIG_FILE
 echo '  --libexecdir       \$libexecdir    $libexecdir' >>$LIBCONFIG_FILE
 echo '  --datadir          \$datadir       $datadir' >>$LIBCONFIG_FILE
+echo '  --datarootdir      \$datarootdir   $datarootdir' >>$LIBCONFIG_FILE
 echo '  --sysconfdir       \$sysconfdir    $sysconfdir' >>$LIBCONFIG_FILE
 echo '  --sharedstatedir   \$sharedstatedir$sharedstatedir' >>$LIBCONFIG_FILE
 echo '  --localstatedir    \$localstatedir $localstatedir' >>$LIBCONFIG_FILE
diff --git a/src/AmberAppender.cpp b/src/AmberAppender.cpp
new file mode 100644
index 0000000..d0feab4
--- /dev/null
+++ b/src/AmberAppender.cpp
@@ -0,0 +1,125 @@
+/*
+ * AmberAppender.cpp
+ *
+ *  Created on: 2012-4-1
+ *      Author: hanyong
+ */
+
+#include "AmberAppender.hh"
+
+#include "xlog/LogItem.pb.h"
+
+using namespace log4cpp;
+using namespace pca;
+
+namespace xlog
+{
+
+std::vector<AmberAppender*> AmberAppender::s_instanceList;
+
+int AmberAppender::registerClass()
+{
+    setInstantiateAmberAppender(&instantiate);
+    return 0;
+}
+
+int AmberAppender::initalizeAll()
+{
+    int nRet = 0;
+    for(unsigned i = 0; i < s_instanceList.size(); ++i)
+    {
+        if (s_instanceList[i]->initialize() != 0)
+        {
+            nRet = -1;
+            break;
+        }
+    }
+    return nRet;
+}
+
+int AmberAppender::flushAll()
+{
+    for(unsigned i = 0; i < s_instanceList.size(); ++i)
+    {
+        s_instanceList[i]->flush();
+    }
+    return 0;
+}
+
+Appender* AmberAppender::instantiate(const std::string& name, const std::string& config,
+        int category, int version, const std::string& queueName, int subqueueId,
+        int bufferThreshold)
+{
+    return new AmberAppender(name, config,
+            category, version, queueName, subqueueId, bufferThreshold);
+}
+
+AmberAppender::AmberAppender(const std::string& name, std::string config, int category, int version,
+        const std::string& queueName, int subqueueId, int bufferThreshold) :
+        LayoutAppender(name), m_config(config), m_category(category), m_version(version),
+        m_queueName(queueName), m_subqueueId(subqueueId),
+        m_bufferThreshold(bufferThreshold), m_currentSize(0)
+{
+    s_instanceList.push_back(this);
+}
+
+AmberAppender::~AmberAppender()
+{
+    close();
+}
+
+int AmberAppender::initialize()
+{
+    return m_client.init(m_config);
+}
+
+bool AmberAppender::reopen()
+{
+    return true;
+}
+
+void AmberAppender::close()
+{
+    flush();
+    // XXX QueueClient need any clean up ?
+}
+
+void AmberAppender::_append(const LoggingEvent& event)
+{
+    pca::Lock lock(&m_mutex);
+    LogItem item;
+    item.set_category(m_category);
+    item.set_version(m_version);
+//    item.set_timestamp(xx);
+    item.set_data(_getLayout().format(event));
+    m_messageList.push_back(item.SerializeAsString());
+
+    std::string& message = m_messageList.back();
+    Item* pItem = new Item((int32_t)message.size(), (char*)message.c_str(), m_subqueueId, -1);
+    pItem->noDestroy();
+    m_items.addItem(pItem);
+    m_currentSize += (int)message.length();
+    if (m_currentSize >= m_bufferThreshold)
+    {
+        flush();
+    }
+}
+
+int AmberAppender::flush()
+{
+    if (m_items.size() <= 0)
+    {
+        return 0;
+    }
+
+    m_client.push(m_queueName, &m_items);
+
+    // 清空所有缓存的数据
+    m_items.~DataItems();
+    new (&m_items) DataItems();
+    m_messageList.clear();
+    m_currentSize = 0;
+    return 0;
+}
+
+} /* namespace xlog */
diff --git a/src/Appender.cpp b/src/Appender.cpp
index c87d842..0086280 100644
--- a/src/Appender.cpp
+++ b/src/Appender.cpp
@@ -14,6 +14,8 @@ namespace log4cpp {
     Appender::AppenderMap* Appender::_allAppenders = 0;
     threading::Mutex Appender::_appenderMapMutex;
 
+    InstantiateAmberAppender* _instantiateAmberAppender;
+
     /* assume _appenderMapMutex locked */
     Appender::AppenderMap& Appender::_getAllAppenders() {
         if (!_allAppenders) 
@@ -80,4 +82,48 @@ namespace log4cpp {
     Appender::~Appender() {
         _removeAppender(this);
     }
+
+    void setInstantiateAmberAppender(InstantiateAmberAppender* instantiate) {
+		_instantiateAmberAppender = instantiate;
+	}
+
+	InstantiateAmberAppender* getInstantiateAmberAppender() {
+		return _instantiateAmberAppender;
+	}
+
+	void Appender::setBackupIndex(int nIndex)
+	{
+	}
+
+	int Appender::getBackupIndex()
+	{
+		return 0;
+	}
+
+	void Appender::setFlushThresholdInKB(int nBytes)
+	{
+	}
+
+	int Appender::getFlushThresholdInKB()
+	{
+		return 0;
+	}
+
+	void Appender::setFlushInterval(int nMicroSec)
+	{
+	}
+
+	int Appender::getFlushInterval()
+	{
+		return 0;
+	}
+
+	void Appender::setAsyncFlush(bool bAsyncFlush)
+	{
+	}
+
+	bool Appender::isAsyncFlush()
+	{
+		return false;
+	}
 }
diff --git a/src/AppendersFactory.cpp b/src/AppendersFactory.cpp
index b30eaa9..2c9ad04 100644
--- a/src/AppendersFactory.cpp
+++ b/src/AppendersFactory.cpp
@@ -7,6 +7,7 @@ namespace log4cpp
 
    std::auto_ptr<Appender> create_file_appender(const FactoryParams&);
    std::auto_ptr<Appender> create_roll_file_appender(const FactoryParams&);
+   std::auto_ptr<Appender> create_time_roll_file_appender(const FactoryParams&);
    std::auto_ptr<Appender> create_idsa_appender(const FactoryParams&);
    std::auto_ptr<Appender> create_nt_event_log_appender(const FactoryParams&);
    std::auto_ptr<Appender> create_remote_syslog_appender(const FactoryParams&);
@@ -23,6 +24,7 @@ namespace log4cpp
          
          af->registerCreator("file", &create_file_appender);
          af->registerCreator("roll file", &create_roll_file_appender);
+         af->registerCreator("time roll file", &create_time_roll_file_appender);
          af->registerCreator("remote syslog", &create_remote_syslog_appender);
          af->registerCreator("abort", &create_abort_appender);
 
diff --git a/src/BufferingAppender.cpp b/src/BufferingAppender.cpp
index de4fed3..1c48732 100644
--- a/src/BufferingAppender.cpp
+++ b/src/BufferingAppender.cpp
@@ -15,11 +15,13 @@ namespace log4cpp
    
    void BufferingAppender::_append(const LoggingEvent& event)
    {
-      if (queue_.size() == max_size_)
-         if (lossy_)
+      if (queue_.size() == max_size_) {
+         if (lossy_) {
             queue_.pop_back();
-         else
+		 } else {
             dump();
+		 }
+	  }
 
       queue_.push_front(event);
       
diff --git a/src/Category.cpp b/src/Category.cpp
index f026ffe..2ede239 100644
--- a/src/Category.cpp
+++ b/src/Category.cpp
@@ -16,10 +16,13 @@
 #include <log4cpp/Category.hh>
 #include <log4cpp/HierarchyMaintainer.hh>
 #include <log4cpp/NDC.hh>
+#include <log4cpp/EventBase.hh>
 #include "StringUtil.hh"
 
 namespace log4cpp {
 
+	EventBase gEventBase;
+
     Category& Category::getRoot() {
         return getInstance("");
     }
@@ -46,6 +49,8 @@ namespace log4cpp {
     }
 
     void Category::shutdown() {
+		gEventBase.notifyStop();
+		gEventBase.wait();
         HierarchyMaintainer::getDefaultMaintainer().shutdown();
     }
 
diff --git a/src/Clock.cpp b/src/Clock.cpp
new file mode 100644
index 0000000..f6baf8f
--- /dev/null
+++ b/src/Clock.cpp
@@ -0,0 +1,27 @@
+#include <log4cpp/Clock.hh>
+#include <stdlib.h>
+
+
+log4cpp::Clock::Clock()
+{
+}
+
+log4cpp::Clock::~Clock()
+{
+}
+
+// Get the current time in miliseconds
+uint64_t log4cpp::Clock::nowMS()
+{
+	struct timeval tv = {0};
+	gettimeofday (&tv, NULL);
+	return (tv.tv_sec * (uint64_t) 1000 + tv.tv_usec / 1000);
+}
+
+// Get the current time in microseconds
+uint64_t log4cpp::Clock::nowUS()
+{
+	struct timeval tv = {0};
+	gettimeofday (&tv, NULL);
+	return (tv.tv_sec * (uint64_t) 1000000 + tv.tv_usec);
+}
diff --git a/src/EventBase.cpp b/src/EventBase.cpp
new file mode 100644
index 0000000..f160860
--- /dev/null
+++ b/src/EventBase.cpp
@@ -0,0 +1,209 @@
+#include <log4cpp/EventBase.hh>
+#include <log4cpp/Clock.hh>
+#include <assert.h>
+#include <errno.h>
+#include <unistd.h>
+
+namespace log4cpp
+{
+
+EventBase::EventBase()
+{
+    m_epollFd = epoll_create(16);
+    assert(m_epollFd != -1);
+
+    // Add the read fd of m_exitSignaler into epoll for notifying worker thread
+    // to exit during stop phase.
+    epoll_event event = {0};
+    event.events = EPOLLIN; 
+    event.data.ptr = NULL;
+    int rc = epoll_ctl(m_epollFd, EPOLL_CTL_ADD, m_exitSignaler.getFd(), &event);
+    assert(rc != -1);
+
+    m_pPendingLayoutAppenderList = new std::list<LayoutAppender *>();
+    m_pLayoutAppenderList = new std::list<LayoutAppender *>();
+
+    m_iMinimumFlushIntervalInMS = s_iDefaultFlushIntervalInMS;
+
+    m_bRunning = false;
+}
+
+EventBase::~EventBase()
+{
+	notifyStop();
+	wait();
+    delete m_pPendingLayoutAppenderList;
+    delete m_pLayoutAppenderList;
+
+    ::close(m_epollFd);
+}
+
+void EventBase::AddLayoutAppender(LayoutAppender *pLayoutAppender)
+{
+    assert(pLayoutAppender != NULL);
+    threading::ScopedLock guardLock(m_pendingListMutex);
+    m_pPendingLayoutAppenderList->push_back(pLayoutAppender);
+    if (m_bRunning == false)
+    {
+        // Activate the underlying I/O worker thread when the first LayoutAppender 
+        // is added for asynchronous monitoring.
+        m_worker.start(worker_routine, this);
+        m_bRunning = true;
+    }
+}
+
+void EventBase::loop()
+{
+    bool bStopping = false;
+
+    while (true)
+    {
+        // First swap out the pending LayoutAppenders for processing
+        {
+            threading::ScopedLock guardLock(m_pendingListMutex);
+            std::list<LayoutAppender *> *pTempLayoutAppenderList = m_pLayoutAppenderList;
+            m_pLayoutAppenderList = m_pPendingLayoutAppenderList;
+            m_pPendingLayoutAppenderList = pTempLayoutAppenderList;
+        }
+
+        // Add the event fd of each LayoutAppender into epoll for monitoring
+        if (m_pLayoutAppenderList->size() > 0)
+        {
+            MonitorLayoutAppenders(m_pLayoutAppenderList);
+            m_pLayoutAppenderList->clear();
+        }
+
+        epoll_event eventBuf[s_iMaxIOEvents];
+
+        // Waiting for events
+        int n = epoll_wait(m_epollFd, &eventBuf[0], s_iMaxIOEvents, m_iMinimumFlushIntervalInMS);
+        if (n == -1)
+        {
+            assert(errno == EINTR);
+            continue;
+        }
+
+        for (int i = 0; i < n; i++)
+        {
+            LayoutAppender *pLayoutAppender = (LayoutAppender *)eventBuf[i].data.ptr;
+
+            if (pLayoutAppender == NULL && m_exitSignaler.recv() > 0)
+            {
+                // Now the worker thread should exit.
+                bStopping = true;
+                break;
+            }
+
+            if ((eventBuf[i].events & EPOLLIN) &&
+                (pLayoutAppender->m_signaler.recv() > 0))
+ 
+            {
+                pLayoutAppender->asyncFlush();
+            }
+        }
+
+        if (bStopping == true) {
+            break;
+        }
+
+        // Check whether flush interval is due for some LayoutAppenders.
+        // Here we didn't use a complicated tree to compute the due
+        // LayoutAppenders accurately. Since usually we only have a few LayoutAppenders
+        // totally, so we just go through all of them for simplicity.
+        uint64_t now = Clock::nowMS();
+        std::map<int, LayoutAppender *>::iterator itor = m_mapLayoutAppenders.begin();
+        for (; itor != m_mapLayoutAppenders.end(); ++itor)
+        {
+            itor->second->timeoutAsyncFlush(now);
+        }
+    }
+    
+    // m_pLayoutAppenderList maybe not empty, should flush every appender of m_pLayoutAppenderList
+    {
+        threading::ScopedLock guardLock(m_pendingListMutex);
+        std::list<LayoutAppender *> *pTempLayoutAppenderList = m_pLayoutAppenderList;
+        m_pLayoutAppenderList = m_pPendingLayoutAppenderList;
+        m_pPendingLayoutAppenderList = pTempLayoutAppenderList;
+    }
+    if (m_pLayoutAppenderList->size() > 0)
+    {
+        std::list<LayoutAppender *>::iterator it = m_pLayoutAppenderList->begin();
+        for (; it != m_pLayoutAppenderList->end(); ++it) {
+            (*it)->asyncFlush();
+        }
+    }
+
+    // Finally flush all the LayoutAppenders to avoid log missing.
+    std::map<int, LayoutAppender *>::iterator itor = m_mapLayoutAppenders.begin();
+    for (; itor != m_mapLayoutAppenders.end(); ++itor) {
+        itor->second->asyncFlush();
+    }
+}
+
+void EventBase::MonitorLayoutAppenders(std::list<LayoutAppender *> *pLayoutAppenderList)
+{
+    std::list<LayoutAppender *>::iterator itor = pLayoutAppenderList->begin();
+    for (; itor != pLayoutAppenderList->end(); ++itor)
+    {
+        LayoutAppender *pLayoutAppender = *itor;
+        int iEventFd = pLayoutAppender->m_signaler.getFd();
+        uint32_t iFlushInterval = pLayoutAppender->getFlushIntervalInMS();
+        if (iFlushInterval == 0)
+            iFlushInterval = s_iDefaultFlushIntervalInMS;
+
+        if (iFlushInterval < m_iMinimumFlushIntervalInMS)
+            m_iMinimumFlushIntervalInMS = iFlushInterval;
+
+        std::map<int, LayoutAppender *>::iterator itor = m_mapLayoutAppenders.find(iEventFd);
+        if (itor == m_mapLayoutAppenders.end())
+        {
+            m_mapLayoutAppenders[iEventFd] = pLayoutAppender;
+        }
+        else
+        {
+            // The file Appender has alrealy been added.
+            continue;
+        }
+
+        epoll_event event = {0};
+        event.events = EPOLLIN; // By default, epoll is level triggered.
+        event.data.ptr = pLayoutAppender;
+
+        int rc = epoll_ctl(m_epollFd, EPOLL_CTL_ADD, iEventFd, &event);
+        assert(rc != -1);
+    }
+}
+
+void EventBase::notifyStop()
+{
+    if (m_bRunning == true)
+        m_exitSignaler.send();
+}
+
+void EventBase::wait()
+{
+    if (m_bRunning == true)
+    {
+        m_worker.stop();
+        m_bRunning = false;
+    }
+    {
+        threading::ScopedLock guardLock(m_pendingListMutex);
+        m_pPendingLayoutAppenderList->clear();
+        m_pLayoutAppenderList->clear();
+        for(std::map<int, LayoutAppender *>::iterator it = m_mapLayoutAppenders.begin();
+            it != m_mapLayoutAppenders.end(); ++it)
+        {
+            int rc = epoll_ctl(m_epollFd, EPOLL_CTL_DEL, it->first, NULL);
+            (void)rc;
+        }
+        m_mapLayoutAppenders.clear();
+    }
+}
+
+void EventBase::worker_routine(void *pArg)
+{
+    ((EventBase*) pArg)->loop();
+}
+
+}
diff --git a/src/FileAppender.cpp b/src/FileAppender.cpp
index fca7595..8e90557 100644
--- a/src/FileAppender.cpp
+++ b/src/FileAppender.cpp
@@ -21,6 +21,8 @@
 #include <log4cpp/FileAppender.hh>
 #include <log4cpp/Category.hh>
 #include <log4cpp/FactoryParams.hh>
+#include <log4cpp/Clock.hh>
+#include <unistd.h>
 
 namespace log4cpp {
 
@@ -31,7 +33,18 @@ namespace log4cpp {
             LayoutAppender(name),
             _fileName(fileName),
             _flags(O_CREAT | O_APPEND | O_WRONLY),
-            _mode(mode) {
+            _mode(mode),
+		    _nFlushThreshold(1024 * 1024),
+		    _nFlushIntervalInMS(1000),
+		    _nAcculatedBytesSinceLastSignal(0),
+		    _nAcculatedBytes(0),
+		    _bAsyncFlush(false) {
+		if (_bAsyncFlush) {
+			_nLastFlushTimeInMS = Clock::nowMS();
+
+			_pPendingBufferList = new std::list<std::string *>();
+			_pBufferList = new std::list<std::string *>();
+		}
         if (!append)
             _flags |= O_TRUNC;
         _fd = ::open(_fileName.c_str(), _flags, _mode);
@@ -42,10 +55,25 @@ namespace log4cpp {
         _fileName(""),
         _fd(fd),
         _flags(O_CREAT | O_APPEND | O_WRONLY),
-        _mode(00644) {
+        _mode(00644),
+		_nFlushThreshold(1024 * 1024),
+		_nFlushIntervalInMS(1000),
+		_nAcculatedBytesSinceLastSignal(0),
+		_nAcculatedBytes(0),
+		_bAsyncFlush(false) {
+		if (_bAsyncFlush) {
+			_nLastFlushTimeInMS = Clock::nowMS();
+
+			_pPendingBufferList = new std::list<std::string *>();
+			_pBufferList = new std::list<std::string *>();
+		}
     }
     
     FileAppender::~FileAppender() {
+		if (_bAsyncFlush) {
+			delete _pPendingBufferList;
+			delete _pBufferList;
+		}
         close();
     }
 
@@ -77,10 +105,34 @@ namespace log4cpp {
     }
 
     void FileAppender::_append(const LoggingEvent& event) {
-        std::string message(_getLayout().format(event));
-        if (!::write(_fd, message.data(), message.length())) {
-            // XXX help! help!
-        }
+		if (_bAsyncFlush == false) {
+			std::string message(_getLayout().format(event));
+			if (!::write(_fd, message.data(), message.length())) {
+				// XXX help! help!
+			}
+			return;
+		}
+
+		std::string *pFormattedStr = new std::string(_getLayout().format(event));
+		uint32_t nLen = (uint32_t)(pFormattedStr->length());
+
+		if (nLen > 0) {
+			if (_nAcculatedBytes >= 200*1024*1024) { // 200M
+				fprintf(stderr, "ERROR: The cached buffer size (%u) has exceed the limit: 200M.\n", _nAcculatedBytes);
+				delete pFormattedStr;
+				return;
+			}
+			_pPendingBufferList->push_back(pFormattedStr);
+			_nAcculatedBytes += nLen;
+			_nAcculatedBytesSinceLastSignal += nLen;
+
+			if (_nAcculatedBytes >= _nFlushThreshold && _nAcculatedBytesSinceLastSignal >= _nFlushThreshold) {
+				_signaler.send();
+				_nAcculatedBytesSinceLastSignal = 0;
+			}
+		} else {
+			delete pFormattedStr;
+		}
     }
 
     bool FileAppender::reopen() {
@@ -99,6 +151,74 @@ namespace log4cpp {
         }      
     }
 
+	void FileAppender::setFlushIntervalInMS(int nFlushIntervalInMS)
+	{
+		_nFlushIntervalInMS = nFlushIntervalInMS;
+	}
+
+	uint64_t FileAppender::getFlushIntervalInMS()
+	{
+		return _nFlushIntervalInMS;
+	}
+
+	void FileAppender::setFlushThresholdInKB(int nBytes)
+	{
+		_nFlushThreshold = nBytes;
+	}
+
+	int FileAppender::getFlushThresholdInKB()
+	{
+		return _nFlushThreshold;
+	}
+
+	void FileAppender::setAsyncFlush(bool bAsyncFlush)
+	{
+		_bAsyncFlush = bAsyncFlush;
+	}
+
+	bool FileAppender::isAsyncFlush()
+	{
+		return _bAsyncFlush;
+	}
+
+	void FileAppender::asyncFlush()
+	{
+		// Swap out the pending buffer list for write and flush
+		std::list<std::string *> *pTempBufferList = NULL;
+		{
+			threading::ScopedLock lockGuard(_appendMutex);
+			pTempBufferList = _pBufferList;
+			_pBufferList = _pPendingBufferList;
+			_pPendingBufferList = pTempBufferList;
+
+			_nAcculatedBytes = 0;
+			_nAcculatedBytesSinceLastSignal = 0;
+		}
+
+		std::list<std::string *>::iterator itor = _pBufferList->begin();
+		for (; itor != _pBufferList->end(); ++itor)
+		{
+			std::string *pBuf = *itor;
+
+			if (!::write(_fd, pBuf->data(), pBuf->length())) {
+				// XXX help! help!
+			}
+			//posix_fadvise(fileno(_file), 0, 0, POSIX_FADV_DONTNEED);
+			delete pBuf;
+		}
+
+		_nLastFlushTimeInMS = Clock::nowMS();
+
+		// Clear the buffer list for usage in the next time.
+		_pBufferList->clear();
+	}
+
+	void FileAppender::timeoutAsyncFlush(uint64_t now)
+	{
+		if (now >= (uint64_t)_nLastFlushTimeInMS + (uint64_t)_nFlushIntervalInMS)
+			asyncFlush();
+	}
+
    std::auto_ptr<Appender> create_file_appender(const FactoryParams& params)
    {
       std::string name, filename;
diff --git a/src/LayoutAppender.cpp b/src/LayoutAppender.cpp
index 5d2f3ba..848b907 100644
--- a/src/LayoutAppender.cpp
+++ b/src/LayoutAppender.cpp
@@ -36,4 +36,21 @@ namespace log4cpp {
     Layout& LayoutAppender::_getLayout() {
         return *_layout;
     }
+
+	void LayoutAppender::setFlushIntervalInMS(int nFlushIntervalInMS)
+	{
+	}
+
+	uint64_t LayoutAppender::getFlushIntervalInMS()
+	{
+		return 0;
+	}
+
+	void LayoutAppender::asyncFlush()
+	{
+	}
+
+	void LayoutAppender::timeoutAsyncFlush(uint64_t now)
+	{
+	}
 }
diff --git a/src/Makefile.am b/src/Makefile.am
index 9beb0f3..4f2f12f 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -54,6 +54,12 @@ liblog4cpp_la_SOURCES = \
 	PThreads.cpp \
 	PortabilityImpl.hh \
 	PortabilityImpl.cpp \
-	AbortAppender.cpp
+	TimeRollingFileAppender.cpp \
+	AbortAppender.cpp \
+	Clock.cpp \
+	EventBase.cpp \
+	Thread.cpp \
+	Signaler.cpp \
+	$(NULL)
 
 liblog4cpp_la_LDFLAGS = -version-info @LT_VERSION@
diff --git a/src/PatternLayout.cpp b/src/PatternLayout.cpp
index a52ad0f..86d6ec8 100644
--- a/src/PatternLayout.cpp
+++ b/src/PatternLayout.cpp
@@ -24,6 +24,7 @@
 #include <iomanip>
 #include <ctime>
 #include <cstdlib>
+#include <cmath>
 #include "Localtime.hh"
 
 #ifdef LOG4CPP_HAVE_INT64_T
